module test_WIN_Counter
(
input [17:0]       WIN_DATA,
input              EN,
input              Start_Write,
input              preHistory_ON,   
input              trigger_event_IN,
input              clk,      
      
output reg         trigger_EN,
output reg         Write_Ready,
output reg [17:0]  WINcnt
);


always @(posedge clk) begin

   if(Start_Write == 0) begin  // 
     
       WINcnt <= WIN_DATA;
       Write_Ready <= 0;    
       if(preHistory_ON == 1) trigger_EN <= 0;  //        0
       else trigger_EN <= 1;  //   ,      1
   end
   else begin
          
       /*          , 
              ,    */
       if((preHistory_ON == 1)|(trigger_event_IN == 1)) begin 
             
           if(WINcnt == 0) begin  //  
               
               if(trigger_event_IN == 1) Write_Ready <= 1;  //       ,      
               else trigger_EN <= 1;  //         
           
               WINcnt <= WIN_DATA;  //  
           end
           else if((trigger_EN == 1) & (trigger_event_IN == 0)) WINcnt <= WIN_DATA; //   ,     ,   
           else WINcnt <= WINcnt - 1'b1;  //               
      end
  end

end
endmodule
